"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * hornet-js-utils - Partie commune et utilitaire à tous les composants hornet-js
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.3.0
 * @link git+https://github.com/diplomatiegouvfr/hornet-js.git
 * @license CECILL-2.1
 */
var CodesError = /** @class */ (function () {
    function CodesError() {
    }
    CodesError.DEFAULT_ERROR_MSG = "Erreur inattendue.";
    /**
     * codes error SEQUELIZE 10000 - 10099
     */
    CodesError.SEQUELIZE_CONNECTION_REFUSED = 10001;
    CodesError.SEQUELIZE_HOST_NOT_FOUND = 10002;
    CodesError.SEQUELIZE_HOST_NOT_REACHABLE = 10003;
    CodesError.SEQUELIZE_INVALID_CONNECTION = 10004;
    CodesError.SEQUELIZE_CONNECTION = 10005;
    CodesError.SEQUELIZE_INSTANCE_ERROR = 10006;
    CodesError.SEQUELIZE_CONNECTION_TIMEOUT = 10007;
    CodesError.SEQUELIZE_TIMEOUT_ERROR = 10008;
    CodesError.SEQUELIZE_ACCESSDENIED = 10009;
    CodesError.SEQUELIZE_CONNECTION_ERROR = 10010;
    CodesError.SEQUELIZE_EXCLUSION_ERROR = 10011;
    CodesError.SEQUELIZE_FOREIGN_KEY_ERROR = 10012;
    CodesError.SEQUELIZE_VALIDATION_ERROR = 10013;
    CodesError.SEQUELIZE_UNIQUE_ERROR = 10014;
    CodesError.SEQUELIZE_DATABASE_ERROR = 10015;
    CodesError.SEQUELIZE_OPTIMISTIC_LOCK_ERROR = 10020;
    /**
     * codes error BINDING 10100 - 10199
     */
    CodesError.BINDING_ERROR = 10101;
    /**
     * codes error BINDING 10200 - 10299
     */
    CodesError.ROUTE_ERROR = 10201;
    /**
     * codes error DATASOURCE 10300 - 10399
     */
    CodesError.DATASOURCE_FETCH_ERROR = 10301;
    CodesError.DATASOURCE_SORT_ERROR = 10302;
    CodesError.DATASOURCE_FILTER_ERROR = 10303;
    CodesError.DATASOURCE_ADD_ERROR = 10304;
    CodesError.DATASOURCE_DELETE_ERROR = 10305;
    CodesError.DATASOURCE_RESPONSE_ERROR = 10306;
    CodesError.DATASOURCE_SORT_ARGS_ERROR = 10307;
    CodesError.DATASOURCE_CONFIGURATION_ERROR = 10320;
    /**
     * codes error INJECT 10400 - 10499
     */
    CodesError.INJECT_ERROR = 10400;
    CodesError.INJECT_ALREADY_DEFINED_ERROR = 10401;
    CodesError.INJECT_NOT_DEFINED_ERROR = 10402;
    /**
     * codes error NODEMAILER 10500 - 10599
     */
    CodesError.NODEMAILER_AUTH_ERROR = 10500;
    CodesError.NODEMAILER_SERVER_NOTFOUND = 10501;
    CodesError.NODEMAILER_SERVER_TIMEOUT = 10502;
    CodesError.NODEMAILER_UNKNOWN = 10599;
    /**
     * codes error CLAMAV 10600 - 10699
     */
    CodesError.CLAMAV_SCAN_INFECTED = 10600;
    CodesError.CLAMAV_SCAN_REMOVE = 10601;
    CodesError.CLAMAV_SCAN_TIMEOUT = 10602;
    CodesError.CLAMAV_SCAN_RESPONSE_MALFORMED = 10603;
    CodesError.CLAMAV_SCAN_UNKNOWN = 10604;
    /**
     * code error BATCH 10700 - 10799
     */
    CodesError.BATCH_OPTIONS_UNDEFINED = 10700;
    /**
     * code error REFERENTIEL 10800 - 10899
     */
    CodesError.REFERENTIEL_TABLE_NOTFOUND = 10800;
    CodesError.REFERENTIEL_HORNET_SEQUELIZE_MODEL_NOTFOUND = 10801;
    CodesError.REFERENTIEL_HORNET_SEQUELIZE_ENTITY_NOTFOUND = 10802;
    return CodesError;
}());
exports.CodesError = CodesError;

//# sourceMappingURL=codes-error.js.map
